<?php
/*
Template Name: Blog Posts
*/
get_header(); ?>
<div class="single-page-title">
	<div class="container">
		<div class="page-title">
			<div class="top-title"><?php the_field('top_title'); ?></div>
			<h2 class="content-title"><?php the_title(); ?></h2>
		</div>
	</div>
</div>
<div class="blog-container">
<div class="container inner">
	<div class="row">

		<div class="col-md-12">
				<div class="col-md-8">
					<?php
					 $paged = (get_query_var('paged')) ? get_query_var('paged') : 1; 
					    $args = array(
					        'post_type' => 'videos',
					        'posts_per_page' => 9,
					        'paged' => $paged
					    );
					    $your_query = new WP_Query( $args );
					    ?>
						<?php query_posts('category_name=blog&post_type=post&post_status=publish&posts_per_page=1&paged='. get_query_var('paged')); ?>
						<?php if( have_posts() ): ?>
						<?php while( have_posts() ): the_post(); ?>
							<div class="post">
										<div class="post-media">
											<a href="<?php the_permalink(); ?>"><?php the_post_thumbnail(); ?></a>
										</div>
										<div class="post-details">
										<div class="post-title">
											<h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>
										</div>
										<div class="post-date">
											<?php $date = the_date('F d Y','','',false); ?>
											<span><?php echo date('d', strtotime($date)); ?></span>
											<span><?php echo date('M', strtotime($date)); ?></span>
										</div>
										<div class="post-body">
											<?php the_excerpt(__('Continue reading »','example')); ?> 
										</div>
										</div>
								</div>
						<?php endwhile; ?>
							<div class="clear"></div>
							<nav class="pagination">
								<?php pagination_bar(); ?>
								</nav>
						<?php else: ?>
						<div id="post-404" class="noposts">
							<p><?php _e('None found.','example'); ?></p>
						</div><!-- /#post-404 -->
						<?php endif; wp_reset_query(); ?>
				</div>
					<div class="col-md-4">
							<div class="blog-sidebar">
								<!-- <?php get_sidebar(); ?> -->
								<?php 
									if (is_active_sidebar( 'blog-sidebar')) { 
									dynamic_sidebar( 'blog-sidebar'); } 
								?>
							</div>
					</div>
		</div>
	</div>
</div>
</div>

<?php get_footer(); ?>