<?php 
// Register Custom Navigation Walker
require_once('wp-bootstrap-navwalker.php');
function wpbootstrap_scripts_with_jquery()
{
		wp_deregister_script( 'jquery' );
	// Register the script like this for a theme:
	wp_register_script( 'custom-script', get_template_directory_uri() . '/bootstrap/js/bootstrap.js', array( 'jquery' ) );
	// For either a plugin or a theme, you can then enqueue the script:
	wp_enqueue_script( 'custom-script' );
}
add_action( 'wp_enqueue_scripts', 'wpbootstrap_scripts_with_jquery' );

function jquery()
{
	// Register the script like this for a theme:
	wp_register_script( 'jquery', get_template_directory_uri() . '/bootstrap/js/jquery-3.2.1.min.js' );
	// For either a plugin or a theme, you can then enqueue the script:
	wp_enqueue_script( 'jquery' );
}
add_action( 'wp_enqueue_scripts', 'jquery' );

// Add Image Size
	add_image_size( 'nms-feature-size', 0, 0, true );
	add_theme_support( 'post-thumbnails' );


//* Register widget areas
if ( function_exists('register_sidebar') )
	register_sidebar(array(
		'name' => 'Home Section 1',
		'id' => 'home-section-1',
		'before_widget' => '<div id="%1$s" class="%2$s">',
		'after_widget' => '</div>',
		'description' => 'Appears in Home Page',
	));
	register_sidebar(array(
		'name' => 'Home Section 2',
		'id'          => 'home-section-2',
		'before_widget' => '<div id="%1$s" class="%2$s">',
    'after_widget' => '</div>',
		'description' => 'Appears in Home Page',
	));
	register_sidebar(array(
		'name' => 'Home Section 3',
		'id'          => 'home-section-3',
		'before_widget' => '<div id="%1$s" class="%2$s">',
    'after_widget' => '</div>',
		'description' => 'Appears in Home Page',
	));
	register_sidebar(array(
		'name' => 'Sub Footer',
		'id'          => 'footer-section-4',
		'before_widget' => '<div id="%1$s" class="%2$s">',
    'after_widget' => '</div>',
		'description' => 'Appears in Home Page',
	));
	register_sidebar(array(
		'name' => 'Blog-Sidebar',
		'id'          => 'blog-sidebar',
		'before_widget' => '<div id="%1$s" class="%2$s">',
    	'after_widget' => '</div>',
		'description' => 'Appears in Home Page',
	));
	register_sidebar(array(
		'name' => 'Presskit-Sidebar',
		'id'          => 'presskit-sidebar',
		'before_widget' => '<div id="%1$s" class="%2$s">',
    	'after_widget' => '</div>',
		'description' => 'Appears in Home Page',
	));


register_nav_menus( array(
		'primary' => __( 'Primary Menu', 'nmsTheme' ),
) );


//blog and presskits pagination

function pagination_nav() {
    global $wp_query;
 
    if ( $wp_query->max_num_pages > 1 ) { ?>
        <nav class="pagination" role="navigation">
            <div class="nav-previous"><?php next_posts_link( '&larr; Older posts' ); ?></div>
            <div class="nav-next"><?php previous_posts_link( 'Newer posts &rarr;' ); ?></div>
        </nav>
<?php }
}
function pagination_bar() {
    global $wp_query;
 
    $total_pages = $wp_query->max_num_pages;
 
    if ($total_pages > 1){
        $current_page = max(1, get_query_var('paged'));
 
        echo paginate_links(array(
            'base' => get_pagenum_link(1) . '%_%',
            'format' => '/page/%#%',
            'current' => $current_page,
            'total' => $total_pages,
        ));
    }
}





add_action( 'wp_footer', function () { ?>

    <script language="javascript" type="text/javascript">
    $(document).ready(function(){
					$('.pops').fadeOut();	
					$('.navbar-nav li a[title="Contact Us"], #contact-btn').click(function(e){
							e.preventDefault();
							$('.pops').fadeIn('fast');
							$('body').css("overflow", "hidden")
						});
						$('.overlay-close').click(function(){
								$('.pops').fadeOut();
							$('body').css("overflow", "auto")
						});
				});


				// Select all links with hashes
			$('a[href*="#"]')
				// Remove links that don't actually link to anything
				.not('[href="#"]')
				.not('[href="#0"]')
				.click(function(event) {
					// On-page links
					if (
						location.pathname.replace(/^\//, '') == this.pathname.replace(/^\//, '') 
						&& 
						location.hostname == this.hostname
					) {
						// Figure out element to scroll to
						var target = $(this.hash);
						target = target.length ? target : $('[name=' + this.hash.slice(1) + ']');
						// Does a scroll target exist?
						if (target.length) {
							// Only prevent default if animation is actually gonna happen
							event.preventDefault();
							$('html, body').animate({
								scrollTop: target.offset().top
							}, 1000, function() {
								// Callback after animation
								// Must change focus!
								var $target = $(target);
								$target.focus();
								if ($target.is(":focus")) { // Checking if the target was focused
									return false;
								} else {
									$target.attr('tabindex','-1'); // Adding tabindex for elements not focusable
									$target.focus(); // Set focus again
								};
							});
						}
					}
				});
    </script>

<?php } );

?>
